stages:
  - build
  - test
  - deploy

workflow:
  rules: 
    - if:  $CI_PIPELINE_SOURCE == "merge_request_event"
      variables:
        RUN_ALL_BUILD: "true"
    - if: $CI_COMMIT_BRANCH == "main"
      variables:
        RUN_ALL_BUILD: "true"
        DEPLOY_PRODUCTION: "true" 
    - if: $CI_COMMIT_BRANCH =~ /^release-v-\d+-\d+-\d+$/ 
      variables:
        RUN_ALL_BUILD: "true"
        DEPLOY_QA : "true"
        DEPLOY_STAGING: "true"

    - if:  $CI_COMMIT_BRANCH =~ /^feature-jira-\d+$/ 
      variables:
        RUN_ALL_BUILD: "true"
        DEPLOY_QA : "true"


build:
  stage: build
  script:
    - echo "Building..."

  rules:
    - if: $RUN_ALL_BUILD == "true" 
    - when: on_success

test:
  stage: test
  script:
    - echo "Testing..."
  rules:
    - if: $RUN_ALL_BUILD == "true" 
    - when: on_success 


deploy_qa:
  stage: deploy
  script:
    - echo "Deploying to QA..."
  rules:
    - if: $DEPLOY_QA == "true"
      when: manual
      allow_failure: true

deploy_staging:
  stage: deploy
  script:
    - echo "Deploying to Staging..."
  rules:
    - if: $DEPLOY_STAGING == "true" 
      when: manual
      allow_failure: true

deploy_production:
  stage: deploy
  script:
    - echo "Deploying to Production..."
  rules:
    - if: $DEPLOY_PRODUCTION == "true"

